#ifndef FUNCTIONS_H
#define FUNCTIONS_H

#include<math.h>
#include<time.h>
#include<stdio.h>
#include<assert.h>
#include<gsl/gsl_vector.h>
#include<gsl/gsl_matrix.h>
#include<gsl/gsl_blas.h>
#include<gsl/gsl_linalg.h>
#define RND (double)rand()/10000

typedef struct {gsl_vector* xs; gsl_vector* ys; gsl_vector* dy;} data;

void print_vector(char s[], gsl_vector* v);
void print_matrix(FILE* stream, gsl_matrix* M);
void GS_decomp(gsl_matrix* A, gsl_matrix* R);
void back_sub(gsl_matrix* R, gsl_vector* x, gsl_vector* b);
void GS_solve(gsl_matrix* Q, gsl_matrix* R, gsl_vector* b, gsl_vector* x);
void GS_inverse(gsl_matrix* Q, gsl_matrix* R, gsl_matrix* B);
void LS_fit(data data, double (*f)(int,double), gsl_vector* c, gsl_vector* dc, gsl_matrix* cova);

#endif