#include "functions.h"

double funcs(int i, double x) {
    switch (i) {
    case 0: return 1; break;
    case 1: return x; break;
    default: return NAN; break;
    }
}

int main() {
    gsl_vector* x = gsl_vector_alloc(9);
    gsl_vector* y = gsl_vector_alloc(9);
    gsl_vector* dy = gsl_vector_alloc(9);
    gsl_vector* c = gsl_vector_alloc(2);
    gsl_vector* dc = gsl_vector_alloc(2);
    gsl_matrix* cova = gsl_matrix_alloc(2,2);
    gsl_vector_set(x,0,1);gsl_vector_set(y,0,log(117.0));gsl_vector_set(dy,0,1.0/20.0);
    gsl_vector_set(x,1,2);gsl_vector_set(y,1,log(100.0));gsl_vector_set(dy,1,1.0/20.0);
    gsl_vector_set(x,2,3);gsl_vector_set(y,2,log(88.0));gsl_vector_set(dy,2,1.0/20.0);
    gsl_vector_set(x,3,4);gsl_vector_set(y,3,log(72.0));gsl_vector_set(dy,3,1.0/20.0);
    gsl_vector_set(x,4,6);gsl_vector_set(y,4,log(53.0));gsl_vector_set(dy,4,1.0/20.0);
    gsl_vector_set(x,5,9);gsl_vector_set(y,5,log(29.5));gsl_vector_set(dy,5,1.0/20.0);
    gsl_vector_set(x,6,10);gsl_vector_set(y,6,log(25.2));gsl_vector_set(dy,6,1.0/20.0);
    gsl_vector_set(x,7,13);gsl_vector_set(y,7,log(15.2));gsl_vector_set(dy,7,1.0/20.0);
    gsl_vector_set(x,8,15);gsl_vector_set(y,8,log(11.1));gsl_vector_set(dy,8,1.0/20.0);
    data data = {.xs=x,.ys=y,.dy=dy};

    LS_fit(data,&funcs,c,dc,cova);

    FILE* data_points_stream = fopen("data.txt","w");
    for(int i=0;i<9;i++) {fprintf(data_points_stream,"%g %g %g\n",gsl_vector_get(x,i),gsl_vector_get(y,i),gsl_vector_get(dy,i));}
    fclose(data_points_stream);

    FILE* fit_stream = fopen("fit.txt","w");
    double fit_0 = gsl_vector_get(c,0);
    double fit_1 = gsl_vector_get(c,1);
    for(double k=gsl_vector_get(x,0);k<gsl_vector_get(x,8);k+=1.0/36) {
        double fit = fit_0+fit_1*k;
        double fit_minus = (fit_0-gsl_vector_get(dc,0))+(fit_1-gsl_vector_get(dc,0))*k;
        double fit_plus = (fit_0+gsl_vector_get(dc,0))+(fit_1+gsl_vector_get(dc,0))*k;
        fprintf(fit_stream,"%g %g %g %g\n",k,fit,fit_minus,fit_plus);
    }
    fclose(fit_stream);

    FILE* values_stream = fopen("values.txt","w");
    double half = -log(2)/gsl_vector_get(c,1);
    fprintf(values_stream,"The half life of ThX from a least squares fit: %g days\nCompared to the modern value: 3.6319 days\n",half);
    fprintf(values_stream,"Covariance matrix of fitting parameters:\n");
    print_matrix(values_stream,cova);
    fprintf(values_stream,"Meaning that the uncertainty in the lambda parameter is: %g\n",gsl_vector_get(dc,1));
    double half_min = -log(2)/(gsl_vector_get(c,1)-gsl_vector_get(dc,1));
    double half_max = -log(2)/(gsl_vector_get(c,1)+gsl_vector_get(dc,1));
    fprintf(values_stream,"Thus the half life is between %g and %g days\n",half_min,half_max);
    fclose(values_stream);


    gsl_vector_free(x);
    gsl_vector_free(y);
    gsl_vector_free(dy);
    gsl_vector_free(c);
    gsl_vector_free(dc);
    gsl_matrix_free(cova);
return 0;
}