#ifndef FUNCTIONS_H
#define FUNCTIONS_H

#include<stdio.h>
#include<math.h>
#include<gsl/gsl_vector.h>
#include<gsl/gsl_matrix.h>
#include<stdlib.h>
#include<gsl/gsl_linalg.h>
#include<gsl/gsl_blas.h>
#include<assert.h>

typedef struct {double value; double error;} returns;

double f(double x);
double g(double x);
double h(double x);
double x(double t, double a, double b);
double w(double w, double a, double b);
double CC(double f(double), double x, double a, double b);
double a_inf(double f(double), double x, double b);
double b_inf(double f(double), double x, double a);
double both_inf(double f(double), double x);
double driver(double f(double), double org_a, double org_b, double a, double b, double acc, double eps,\
              double two, double three, double* high, double* low, double* xs, int* evals, double* error, char* type);
returns integrate(double f(double), double a, double b, double acc, double eps, char* is_CC);





#endif