#ifndef FUNCTIONS_H
#define FUNCTIONS_H

#include<math.h>
#include<time.h>
#include<stdio.h>
#include<float.h>
#include<assert.h>
#include<gsl/gsl_vector.h>
#include<gsl/gsl_matrix.h>
#include<gsl/gsl_blas.h>
#include<gsl/gsl_linalg.h>
#define RND (double)rand()/10000
#define DX sqrt(DBL_EPSILON)
typedef struct {double* b; double* c; double* d;} cubic_coefs;

void f(gsl_vector* x, gsl_vector* fx);
void radial(double r, gsl_vector* y, gsl_vector* dydr);
double Fe_simple(double energy, double rmax, char* save_path);
void aux(gsl_vector* x, gsl_vector* fx);
void print_vector(char s[], gsl_vector* v);
void print_matrix(gsl_matrix* M);
void GS_decomp(gsl_matrix* A, gsl_matrix* R);
void GS_solve(gsl_matrix* Q, gsl_matrix* R, gsl_vector* b, gsl_vector* x);
void rkstep12(void f(double t,gsl_vector* y,gsl_vector* dydt),double t,gsl_vector* yt,double h,gsl_vector* yh,gsl_vector* err);
int driver(void f(double,gsl_vector*,gsl_vector*),double a,gsl_vector* ya,double b,gsl_vector* yb,\
           double h,double acc,double eps,char* save_path);
int search(int n, double* x, double z);
void cubic_interpol(int n, double x[], double y[], cubic_coefs* a);
double cubic_eval(cubic_coefs coefs, int n, double* x, double* y, double z);
void newton_root(void f(gsl_vector* x, gsl_vector* fx), gsl_vector* x, double eps);

#endif